//+------------------------------------------------------------------+
//|                                          i_PortfolioClose_v1.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- input parameters
extern double       Lots=0.1;
//---- buffers
double CloseBuffer[];
string symbol[14]={"GBPUSD","EURGBP","GBPCHF","CHFJPY","AUDJPY","EURJPY","USDCHF",
                   "NZDJPY","AUDUSD","USDJPY","EURUSD","EURCHF","GBPJPY","NZDUSD"};
int Barsi[14],BarsMin;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,CloseBuffer); 
   IndicatorDigits(2);
   IndicatorShortName("i_PortfolioClose_v1   ");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
  int s;
//----
  if(AccountBalance()!=0)
    {
    for(s=0;s<14;s++)
      {
      if(MarketInfo(symbol[s],MODE_TRADEALLOWED)==false || iOpen(symbol[s],0,0)==0)
        {
        Alert("  i_PortfolioClose_v1     ",symbol[s]);return(0);
        }
      else if(MarketInfo(symbol[s],MODE_TRADEALLOWED)==true || iOpen(symbol[s],0,0)!=0)
        {
      //----   -  (  )
        if(BarsMin==0)
          {
          Barsi[s]=iBars(symbol[s],0);
          }
        BarsMin=Barsi[ArrayMinimum(Barsi)];
        } 
      }
    }
    
//----
  int limit;
  int counted_bars=IndicatorCounted();
  
//----     
  if(counted_bars>0) counted_bars--;
  limit=Bars-counted_bars;
  if(limit>BarsMin)limit=BarsMin;
//----  
  double Sum;
  for(int i=0;i<limit;i++)
    {
    Sum=0;
    for(s=0;s<14;s++)
      {
      int bar=iBarShift(symbol[s],0,Time[i]);
      Sum=Sum+
          MarketInfo(symbol[s],MODE_MARGINREQUIRED)*Lots*
          (iClose(symbol[s],0,bar)+
          MarketInfo(symbol[s],MODE_SPREAD)*
          MarketInfo(symbol[s],MODE_POINT))/
          MarketInfo(symbol[s],MODE_ASK);
      }
    CloseBuffer[i]=Sum;
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+